#include "aswm/event_handlers/map.h"
#include <stdio.h>
#include <X11/Xutil.h>

void OnMapRequest(Window root, const XMapRequestEvent* e) {
	printf("XMapRequestEvent %lu\n", e->window);

	{
		XTextProperty text_property;
		XGetWMName(e->display, e->window, &text_property);
		printf("\tname: %s\n", text_property.value);
	}
	{
		XClassHint class;
		XGetClassHint(e->display, e->window, &class);
		printf("\tclass: %s, %s\n", class.res_class, class.res_name);
	}

	int screen_number = XDefaultScreen(e->display);
	int full_width = XDisplayWidth(e->display, screen_number);
	int full_height = XDisplayWidth(e->display, screen_number);

	// Automatically reconfigure position and size of the window
	XWindowChanges changes;
	changes.x = 0;
	changes.y = 0;
	changes.width = full_width;
	changes.height = full_height;

	printf("\tx = %i\n", changes.x);
	printf("\ty = %i\n", changes.y);
	printf("\tw = %i\n", changes.width);
	printf("\th = %i\n", changes.height);

	XConfigureWindow(e->display, e->window, CWX | CWY | CWWidth | CWHeight, &changes);

	XMapWindow(e->display, e->window);
}
